#ifndef CUB43PCILP_H
#define CUB43PCILP_H

    #define CUB_SUCCESS                  0  /* The operation completed successfully.                 */
    #define CUB_ERR_DEVICENOTEXIST       1  /* The system cannot find the device specified.          */
    #define CUB_ERR_ALREADYOPENED        2  /* The device name is already in use.                    */
    #define CUB_ERR_CLOSED               3  /* "CubOpenHandle()" has not been called. Unused error code. */
    #define CUB_ERR_INVALIDPARAM         4  /* The handle is invalid.                                */
    #define CUB_ERR_NORESOUCE            5  /* There is not enough resources.                        */
    #define CUB_ERR_FAILED               6  /* Failed during processing. The cause is unknown.       */
    #define CUB_NOT_CALLYET              99 /* API function is not called.                           */

#define CUBAPI __stdcall


#ifdef __cplusplus
extern "C" {
#endif
    UINT CUBAPI CubGetVersion(void);
    UINT CUBAPI CubGetLastError(void);
    INT  CUBAPI CubCountDevice(void);
    HANDLE CUBAPI CubOpenHandle(int Instance);
    BOOL CUBAPI CubCloseHandle(HANDLE CUBHandle);
    BOOL CUBAPI CubReadByte(HANDLE CUBHandle, ULONG Adr, BYTE* Dat);
    BOOL CUBAPI CubReadWord(HANDLE CUBHandle, ULONG Adr, WORD* Dat);
    BOOL CUBAPI CubWriteByte(HANDLE CUBHandle, ULONG Adr, BYTE Dat);
    BOOL CUBAPI CubWriteWord(HANDLE CUBHandle, ULONG Adr, WORD Dat);
    BOOL CUBAPI CubResetBoard(HANDLE CUBHandle);
    INT  CUBAPI CubBoardID(HANDLE CUBHandle);
    BOOL CUBAPI CubSearchBoard(BYTE *board_num, BYTE *board_id_list);
    BOOL CUBAPI CubGetInterrupt0Count(HANDLE CUBHandle, BYTE *int0Counter);
    BOOL CUBAPI CubGetInterrupt1Count(HANDLE CUBHandle, BYTE *int1Counter);
    BOOL CUBAPI CubClearInterrupt0Count(HANDLE CUBHandle);
    BOOL CUBAPI CubClearInterrupt1Count(HANDLE CUBHandle);
    BOOL CUBAPI CubGetInterrupt0StatusInfo(HANDLE CUBHandle, WORD *int0Info);
    BOOL CUBAPI CubGetInterrupt1StatusInfo(HANDLE CUBHandle, WORD *int1Info);
    BOOL CUBAPI CubClearInterrupt0StatusInfo(HANDLE CUBHandle, WORD clearInt0Info);
    BOOL CUBAPI CubClearInterrupt1StatusInfo(HANDLE CUBHandle, WORD clearInt1Info);

#ifdef __cplusplus
}
#endif

#endif /* #ifndef CUB43PCILP_H */
